diff --git a/meta-multimedia/recipes-multimedia/openal/openal-soft/0001-Use-BUILD_CC-to-compile-native-tools.patch b/meta-multimedia/recipes-multimedia/openal/openal-soft/0001-Use-BUILD_CC-to-compile-native-tools.patch
new file mode 100644
index 0000000000..16f123fad8
--- /dev/null
+++ b/meta-multimedia/recipes-multimedia/openal/openal-soft/0001-Use-BUILD_CC-to-compile-native-tools.patch
@@ -0,0 +1,33 @@
+From 29217932c34d7e3368764ab64879dc6f1edab1a6 Mon Sep 17 00:00:00 2001
+From: Khem Raj <raj.khem@gmail.com>
+Date: Mon, 14 Jan 2019 11:19:44 -0800
+Subject: [PATCH] Use host compiler to compile native tools
+
+Helps in cross compiling
+
+Upstream-Status: Inappropriate [OE-Specific]
+
+Signed-off-by: Khem Raj <raj.khem@gmail.com>
+
+---
+ CMakeLists.txt | 5 ++---
+ 1 file changed, 2 insertions(+), 3 deletions(-)
+
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 39b80250..d6bdf8ed 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -1288,11 +1288,10 @@ FILE(MAKE_DIRECTORY "${NATIVE_BIN_DIR}")
+ SET(BIN2H_COMMAND  "${NATIVE_BIN_DIR}bin2h")
+ SET(BSINCGEN_COMMAND  "${NATIVE_BIN_DIR}bsincgen")
+ ADD_CUSTOM_COMMAND(OUTPUT "${BIN2H_COMMAND}" "${BSINCGEN_COMMAND}"
+-    COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" "${NATIVE_SRC_DIR}"
+     COMMAND ${CMAKE_COMMAND} -E remove "${BIN2H_COMMAND}" "${BSINCGEN_COMMAND}"
+-    COMMAND ${CMAKE_COMMAND} --build . --config "Release"
++    COMMAND gcc "${NATIVE_SRC_DIR}bin2h.c" -o "${BIN2H_COMMAND}" -lm
++    COMMAND gcc "${NATIVE_SRC_DIR}bsincgen.c" -o "${BSINCGEN_COMMAND}" -lm
+     WORKING_DIRECTORY "${NATIVE_BIN_DIR}"
+-    DEPENDS "${NATIVE_SRC_DIR}CMakeLists.txt"
+     IMPLICIT_DEPENDS C "${NATIVE_SRC_DIR}bin2h.c"
+                      C "${NATIVE_SRC_DIR}bsincgen.c"
+     VERBATIM
diff --git a/meta-multimedia/recipes-multimedia/openal/openal-soft/0002-makehrtf-Disable-Wstringop-truncation.patch b/meta-multimedia/recipes-multimedia/openal/openal-soft/0002-makehrtf-Disable-Wstringop-truncation.patch
new file mode 100644
index 0000000000..8420386e36
--- /dev/null
+++ b/meta-multimedia/recipes-multimedia/openal/openal-soft/0002-makehrtf-Disable-Wstringop-truncation.patch
@@ -0,0 +1,31 @@
+From 07ef86e33ed6f7585f0dfaa1732ea17c816655a4 Mon Sep 17 00:00:00 2001
+From: Khem Raj <raj.khem@gmail.com>
+Date: Mon, 14 Jan 2019 11:45:42 -0800
+Subject: [PATCH] makehrtf: Disable Wstringop-truncation
+
+Upstream-Status: Inappropriate [Should be fixed in code]
+Signed-off-by: Khem Raj <raj.khem@gmail.com>
+---
+ utils/makehrtf.c | 2 ++
+ 1 file changed, 2 insertions(+)
+
+diff --git a/utils/makehrtf.c b/utils/makehrtf.c
+index 0bd36849..0abe4252 100644
+--- a/utils/makehrtf.c
++++ b/utils/makehrtf.c
+@@ -862,6 +862,7 @@ static int TrReadOperator(TokenReaderT *tr, const char *op)
+  * pattern string are replaced with the replacement string.  The result is
+  * truncated if necessary.
+  */
++#pragma GCC diagnostic ignored "-Wstringop-truncation"
+ static int StrSubst(const char *in, const char *pat, const char *rep, const size_t maxLen, char *out)
+ {
+     size_t inLen, patLen, repLen;
+@@ -900,6 +901,7 @@ static int StrSubst(const char *in, const char *pat, const char *rep, const size
+     return !truncated;
+ }
+ 
++#pragma GCC diagnostic pop
+ 
+ /*********************
+  *** Math routines ***
diff --git a/meta-multimedia/recipes-multimedia/openal/openal-soft_1.15.1.bb b/meta-multimedia/recipes-multimedia/openal/openal-soft_1.19.1.bb
similarity index 63%
rename from meta-multimedia/recipes-multimedia/openal/openal-soft_1.15.1.bb
rename to meta-multimedia/recipes-multimedia/openal/openal-soft_1.19.1.bb
index e0f1a26de4..a9cdfac8a9 100644
--- a/meta-multimedia/recipes-multimedia/openal/openal-soft_1.15.1.bb
+++ b/meta-multimedia/recipes-multimedia/openal/openal-soft_1.19.1.bb
@@ -1,13 +1,18 @@
 SUMMARY = "OpenAL is a cross-platform 3D audio API"
 HOMEPAGE = "http://kcat.strangesoft.net/openal.html"
 LICENSE = "GPLv2"
-LIC_FILES_CHKSUM = "file://COPYING;md5=facc3a8f452930083bbb95d82b989c35"
+LIC_FILES_CHKSUM = "file://COPYING;md5=0f159f19f9377e1895fbb477d5a7953e"
 
-inherit cmake
+inherit cmake pkgconfig
 
-SRC_URI = "http://kcat.strangesoft.net/openal-releases/${BP}.tar.bz2"
-SRC_URI[md5sum] = "ea83dec3b9655a27d28e7bc7cae9cd71"
-SRC_URI[sha256sum] = "0e29a162f0841ccb4135ce76e92e8a704589b680a85eddf76f898de5236eb056"
+# openal-soft-1.19.1
+SRCREV = "6761218e51699f46bf25c377e65b3e9ea5e434b9"
+SRC_URI = "git://github.com/kcat/openal-soft \
+           file://0001-Use-BUILD_CC-to-compile-native-tools.patch \
+           file://0002-makehrtf-Disable-Wstringop-truncation.patch \
+           "
+
+S = "${WORKDIR}/git"
 
 PACKAGECONFIG ?= "${@bb.utils.filter('DISTRO_FEATURES', 'alsa pulseaudio', d)}"
 PACKAGECONFIG[alsa] = "-DALSA=TRUE, -DALSA=FALSE, alsa-lib"